var data, index = 0;
var width = window.innerWidth,
    height = window.innerHeight,
    format = d3.format(",d"),
    colorFunc,
    opactiyFunc,
    pointerFunc,
    timePointerFunc,
    cIndex = true,
    g; //


function Start() {
    //========= Color and Layout functions =========
    _("interval", 0),
    _("attribute", 'RVIR');

    _('colorScale', d3.scale.category20c() )

     // _('colorScale', d3.scale.linear())
     //    .domain(_("RvirMinMax"))
     //    .range(['rgb(0, 85, 184)', 'rgb(255, 215, 0)'])

    _('opacity', d3.scale.linear() )
        .range([0.1, 1.0])

    _('pack', d3.layout.pack() )
        .sort(null)
        .padding(5)
        .size([width*.5, height - 100])
        .value(function(d) { return d.scale ? d.rs * d.scale : d.rs })
        // .radius(function(d) { return d.rs })

    _('tree', d3.layout.tree() )
        .size([width/2, height - 100])
        .value(function(d) { return d.rs })

    _('diagonal', d3.svg.diagonal() )
        .projection(function(d) { return [d.x, d.y]; });

    var zoom = d3.behavior.zoom()
        .center([width / 2, height / 2])
        .scaleExtent([1, 10])
        .on("zoom", zoomed);


    //========= DOM elements =========
    _('svg', d3.select("#halos").append("svg") )
        .attr("width", width)
        .attr("height", height * .9)
      .append("g")
        .call(zoom);

    var rect = _('svg').append("rect")
        .attr("width", width)
        .attr("height", height*9)
        .style("fill", "white")
        .style("pointer-events", "all");


    _('svg').append("g")
        .attr("id", "colorbar")
    _("ColorBar", Colorbar())

    // d3.select('#timebar').call(_('Colorbar'))

    g = _("svg").append('g')
        .attr('width', width)
        .attr('height', height)

    function zoomed() {
      g.attr("transform", "translate(" + d3.event.translate + ")scale(" + d3.event.scale + ")");
    }

    _("queue")
        .defer(d3.json, 'js/data/hlist_1.0.json') // ../../DarkSky/js/assets/
        .await(OnCreate)
}

function OnCreate(error, roots) {

    if (error) console.error('fuck, OnCreate didnt work');

    InitButtons("#button");
    DrawHlist(roots);
}



function DrawHlist( data ) {
    InitScales(data)

    hlist = { "name": 'hlist', "children": data }


    colorFunc = setColor( _('attribute') );
    opactiyFunc = setOpacity( _('attribute'))

    var node = _("svg").append('g')
        .attr('class', 'temp')
        .attr('width', width)
        .attr('height', height)
        .attr('transform', 'translate(' + (width*.25) * index + ',0)')
        .datum( hlist ).selectAll('circle')
            .data( _("pack").nodes )

        node.attr('class', 'update')
            .style('fill-opacity', opactiyFunc)
            .style('fill', colorFunc )
            .transition()
                .duration(2000)
                .attr('r', setSize)
                .attr('cx', setX)
                .attr('cy', setY)

        node.enter().append('circle')
            .attr('class', 'enter')
            .attr('r', 0) // set radius to zero to keep it hidden
            .attr('cx', function(d) {return d.x})
            .attr('cy', function(d) {return d.y})
            .on('mouseover', function(d){
                d3.select(this)
                    .transition()
                        .duration(100)
                        .attr('r', 25 )

                logHaloID(d)
                console.log("clicking me would load my tree")
            })
            .on('mouseout', function(d){
                d3.select(this).transition().duration(100).attr('r', setSize)
            })
            .on('click', function(d) {
                var treePath = 'js/data/trees/' // ../../DarkSky/js/assets/trees  hlist_1.0.json
                    treePath += "tree_674539.json";

                d3.json(treePath, function(error, data) {
                        if (error) throw error;
                        console.log(data);
                        DataPreProc(data, true);
                    })
                // console.log(treePath);
                d3.select('g.temp').remove();

            })
            .transition()
                .duration(100)
                .attr('r', setSize)
                .style('fill-opacity', opactiyFunc)
                .style('fill', colorFunc )
}



function DrawPack() {
    console.log(index);

    var node = g.datum( _('data')[index--] ).selectAll('circle')
        .data( _("pack").nodes );

    node.attr('class', 'update')
        .transition()
            .duration(2000)
            .attr('r', setSize)
            .attr('cx', setX)
            .attr('cy', setY)
            .style('fill-opacity', opactiyFunc)
            .style('fill', colorFunc )
            // .attr("transform", function(d) { return "translate(" + d.x + "," + d.y + ")"; }) // position it in its place though

    node.enter().append('circle')
        .attr('class', 'enter')
        .attr('r', 0) // set radius to zero to keep it hidden
        .attr('cx', setX)
        .attr('cy', setY)
        .on('mouseover', logHaloID)
        .transition()
            .duration(2000)
            .attr('r', setSize)
            .style('fill', colorFunc )
            .style('fill-opacity', opactiyFunc)

    node.exit()
        .attr('class', 'exit')
        .transition()
            .duration(2000)
            .attr('r', 0)
            .remove();

    index = index < 0? _('data').length-1: index;

    if (_('data')[index].children.length === 0)
        index = _('data').length-1;

}

function InitButtons(selection, buttonData) {
    var buttonData = ["Play", "Pause", "Stop", "Color Scheme"] //,
    var buttonDiv = d3.select(selection).append("svg")
        .attr("width", 1000)
        .attr("height", 50);
    var buttons = buttonDiv.selectAll(".updateButton")
        .data(buttonData)
       .enter()
        .append('g')
        .attr("class", "updateButton")
        .on("mousedown", function(d, i) { d3.select(this).style('fill-opacity', .5) })
        .on("mouseup", function(d, i) {
            console.log(d, i);
            d3.select(this).style('fill-opacity', 1.0)
            updateVis(i);
        });
    buttons.append("rect")
        .attr("x", function(d, i) { return (i * height *.25) + 100; })
        .attr("width", 98)
        .attr("height", 25)
        .attr("ry", 5)
        .style("stroke", "#787878")
        .style("fill", "tan");
    buttons.append("text")
        .attr("x", function(d, i) { return (i * height *.25) + (100 / 2) + 98; })
        .attr("y", 12)
        .attr("dy", "0.35em")
        .style("text-anchor", "middle")
        .style("font-size", "15px")
        .text(function(d) { return d; });
}


function ResetColorbar() {
    _("ColorBar", Colorbar() )
        .origin([width * .60, height * .08])
        .scale( _('colorScale') )
        .barlength(height *.8)
        .thickness(20)
        .orient('vertical')

    // d3.select('#colorbar').call(_('Colorbar'))

    pointerFunc = d3.selectAll("#colorbar")
        .transition().duration(700)
        .call(_("ColorBar"));

    d3.selectAll('circle')
        .style('fill', colorFunc)
        // .style('fill-opacity', 1)
}

function updateVis(buttonID) {
    switch(buttonID) {
        case 0:
            AnimationStart();
            break;
        case 1:
            AnimationPause();
            break;
        case 2:
            AnimationStop();
            break;

        case 3:
        console.log(cIndex);
            if (cIndex) {
                cIndex = !cIndex;
                colorFunc = setColor('DEPTH');
                opactiyFunc = setOpacity('DEPTH')
            } else {
                cIndex = !cIndex;
                colorFunc = setColor('RVIR');
                opactiyFunc = setOpacity('RVIR')
            }
            break;

    }
}


function InitScales(dev) {
    console.log("InitScales:", dev);
    _("RadialScaleMinMax", d3.extent(dev, function(d) { return +d.rs }) )
    _("MvirMinMax", d3.extent(dev, function(d) { return +d.mvir }) )
    _("RvirMinMax", d3.extent(dev, function(d) { return +d.rvir }) )
    _("DepthMinMax", [0,10] )

    console.log( _("RadialScaleMinMax"), _("MvirMinMax"), _("RvirMinMax"));
}

function DataPreProc(dev, start) {
    start = start || false;

    InitScales(dev);

    var HALO_LUT = {}; // it can be temporary because we ideally dont want to have to deal with this ever again

    // create our time array to hold each halo
    var time  = d3.range(88, -1, -1).map(function(d) { return {'name':(d + 12)/100, 'children':[]} });

    // Store all halos in an Index by id
    dev.forEach( function(d) {
        d.scale = +d.scale;
        d.id = +d.id;
        d.pid = +d.pid;
        d.upid = +d.upid;
        HALO_LUT[+d.id] = d;
    })

    // // then pre-append ids to their parents..
    console.log('populate the HALO_LUT' );
    dev.forEach( function(d, i) {
        // console.log(d.scale, d.id, d.pid, i );
        if (d.pid !== -1)
            if (HALO_LUT[d.pid])
                if( HALO_LUT[+d.pid].hasOwnProperty('children') )
                    HALO_LUT[+d.pid].children.push(d)
                else
                    HALO_LUT[+d.pid]['children'] = [ d ]
    })

    var j = 0;
    time.forEach(function( tp, i ) {
        var curScale = +tp.name;
        var children = tp.children;

        // idea here being we want to skip those halos weve already traversed
        while( j < dev.length ) {
            var cur = dev[j];
            // console.log('\t',j, cur.scale, cur.id, cur.pid);
            if (cur.scale !== curScale)
                break;

            // halo IS NOT a sub structure
            if (cur.pid === -1)
                children.push( HALO_LUT[cur.id] );

            j++;
        }
    })
    console.log("Do we have data?", time);
    var i = 0;
    while (i < time.length){
        // console.log(i, time[i].name, time[i].children.length);
        if (time[i].children.length < 1){

            time.splice(i,1);
            // console.log(i, time.length);
        } else {
            i++
        }

    }


    _('data', time); index = time.length-1;
    _('time', time);
    // attachDownload('formatted.json', time);
    start? AnimationStart() : null;
}



function logHaloID(d){
    console.log(d.id || d.name)
    pointerFunc.pointTo( +d[_('attribute').toLowerCase()])
}




function AnimationStart(cycle) {
    cycle = cycle || 3000
    DrawPack();
     _('interval', setInterval(function() { DrawPack() }, cycle) )
}

function AnimationPause() {
    clearInterval( _('interval') );
}


function AnimationStop() {
    clearInterval( _('interval') );
    _('index',  _('data').length-1 );
    DrawPack();
}

function SetColorScaleRS() {
     _('colorScale', d3.scale.linear())
        .domain(_("RadialScaleMinMax"))
        .range(['rgb(0, 85, 184)', 'rgb(255, 215, 0)'])
    console.log('colorScale:', _('attribute'), _('colorScale').domain(), _('colorScale').range());
    ResetColorbar()
}

function SetColorScaleMVIR() {
     _('colorScale', d3.scale.linear())
        .domain(_("MvirMinMax"))
        .range(['rgb(98, 38, 158)', 'rgb(118, 32, 87)'])
    console.log('colorScale:', _('attribute'), _('colorScale').domain(), _('colorScale').range());
    ResetColorbar()
}

function SetColorScaleRVIR() {
     _('colorScale', d3.scale.linear())
        .domain(_("RvirMinMax"))
        .range(['rgb(0, 85, 184)', 'rgb(255, 215, 0)'])
    console.log('colorScale:', _('attribute'), _('colorScale').domain(), _('colorScale').range());
    ResetColorbar()
}


function SetColorScaleDEPTH() {
     _('colorScale', d3.scale.category20c() )
    console.log('colorScale:', _('attribute'), _('colorScale').domain(), _('colorScale').range());
    ResetColorbar()
}

function setSize(d, i) { return d.depth < 1 ? 0 : d.r/d.depth ;} // d.rs
function setX(d) {return d.x};
function setY(d) {return d.y};

function setColor(attr) {
    console.log("setting colors to", attr);
    switch(attr){
        case 'RS':
            _("attribute", attr)
            SetColorScaleRS()
            return function(d) { return _('colorScale')(+d.rs)}

        case 'MVIR':
            _("attribute", attr)
            SetColorScaleMVIR()
            return function(d) { return _('colorScale')(+d.mvir)}

        case 'RVIR':
            _("attribute", attr)
            SetColorScaleRVIR()
            d3.selectAll('circle').style('fill', function(d) { return _('colorScale')(+d.rvir)})
            return function(d) { return _('colorScale')(+d.rvir)}

        case 'DEPTH':
            _("attribute", attr)
            SetColorScaleDEPTH()
            d3.selectAll('circle').style('fill', function(d) { return _('colorScale')(+d.r/+d.depth)})
            return function(d) { return _('colorScale')(+d.r/+d.depth)}

    }
}

function setOpacity(attr) {

    switch(attr){
        case 'RS':
             _('opacity')
                .domain(_("RadialScaleMinMax"))
            return function(d) { return _('opacity')(+d.rs)}

        case 'MVIR':
             _('opacity')
                .domain(_("RadialScaleMinMax"))
            return function(d) { return _('opacity')(+d.mvir)}

        case 'RVIR':
             _('opacity')
                .domain(_("RadialScaleMinMax"))
            return function(d) { return _('opacity')(+d.rvir)}

        case 'DEPTH':
             _('opacity')
                .domain(_("DepthMinMax"))
            return function(d) { return _('opacity')(+d.r/+d.depth)}

    }
}


function attachDownload(filename, data) {
    var json = JSON.stringify(data),
        blob = new Blob([json], {type: "application/json"}),
        url = URL.createObjectURL(blob);

    d3.select('#download')
        .append('a')
      .attr('download', filename)
      .attr('href', url)
      .text(filename)
        .append('br')
}

